#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal
#
###2006-0422 - uninstall.pl from QoS v1.8 by NetWhiz modded by catastrophe for use with enhancedipblock v.0.2
# - Included v2.1 easymod routine from DHCP Pack by Tiago
###2006-0515 - modded by catastrophe for use with enhancedipblock v.0.3


require '/var/smoothwall/mods/enhancedipblock/modlib.pl';

# # # # # # # # # # # # # # # # # # #
# check for existing installations  #
# # # # # # # # # # # # # # # # # # #

print "\nUninstalling Enhanced IP Block Page v.0.3, please wait...\n\n";

if (&installed ("/var/smoothwall/langs/base.pl", "# enhancedipblock v.0.2")) {
	print "\nPlease remove # enhancedipblock v.0.2\n";
	print "Note - Run uninstall-020.pl script.\n \n";
	exit;
}

if (-e "/var/smoothwall/mods/enhancedipblock/installed") {
	if (&installed ("/var/smoothwall/mods/enhancedipblock/installed", "# enhancedipblock v.0.2")) {
		print "\nPlease remove # enhancedipblock v.0.2\n";
		print "Note - Run uninstall-020.pl script.\n \n";
		exit;
	}
}

#if (-e "/var/smoothwall/mods/enhancedipblock/installed") {
#	if (! &installed ("/var/smoothwall/mods/enhancedipblock/installed", "# enhancedipblock v.0.3")) {
#		print "\nPlease install # enhancedipblock v.0.3\n";
#		print "Note - Run install.pl script.\n \n";
#		exit;
#	}
#}

# # # # # # # # # # # #
# handle file copying #
# # # # # # # # # # # #

#	$storebkp =	where to store backup of the files that are changed by your mod
#	$moddir =	where your mod files are
#	$wkdir =	where you are changing files (backup from and copy to)
#
#	backupinstall ($file, $wkdir, $storebkp, $moddir);
#	backup ($file, $wkdir, $storebkp);
#	install ($file, $wkdir, $moddir);
#	uninstallrestore ($file, $wkdir, $storebkp);
#	uninstall ($file , $wkdir);
#
#	installed ($file, $string);
#
#	search for $string into $file => 1 found / 0 not found

my $bkp = '/var/smoothwall/mods/enhancedipblock/backup';

$dir = '/home/httpd/cgi-bin';
&uninstallrestore ('ipblock.cgi', $dir, $bkp);

$dir = '/home/httpd/html/help';
&uninstallrestore ('ipblock.cgi.html.en', $dir, $bkp);

$dir = '/var/smoothwall/ipblock';
&backup ('config2', $dir, $bkp);

# # # # # # # # # # # #
# handle file editing #
# # # # # # # # # # # #

my $param = '/var/smoothwall/mods/enhancedipblock/params';

#&easymod ("/home/httpd/cgi-bin/.htaccess", "$param/htaccess.03.d", '3', "/dev/null");

&easymod ("/var/smoothwall/main/ui/alertboxes.en.pl", "$param/alertboxes.en.pl.03.d", '2', "/dev/null");

#&easymod ("/var/smoothwall/header.pl", "$param/header.pl.03.d", '1', "/dev/null");

&easymod ("/var/smoothwall/langs/base.pl", "$param/base.pl.03.d", '17', "/dev/null");
#&easymod21 ("/var/smoothwall/langs/base.pl", "$param/base.pl.03.d", '17', "/dev/null");

#&easymod ("/etc/crontab", "$param/crontab.03.d", '3', "/dev/null");

# # # # # # # # # # # #
# handle file linking #
# # # # # # # # # # # #

#$dir = '/home/httpd/html/ui/assets/3.6/img/pagetitles';
#&uninstall ('page-ipblock.png', $dir);

$dir = "/var/smoothwall/mods/enhancedipblock";
#&uninstall ("enable", $dir);
&uninstall ("installed", $dir);

print "Done\n\n";

# # # #
# end #
# # # #


sub easymod21
{
	my $targetfile = $_[0];
	my $searchfile = $_[1];
	my $linestodelete = $_[2];
	my $replacefile = $_[3];

	open(TARGET, "$targetfile") or die 'Unable to open target file.';
	my @target = <TARGET>;
	close(TARGET);

	open(SEARCH, "$searchfile") or die 'Unable to open search file';
	my @search = <SEARCH>;
	close(SEARCH);

	open(REPLACE, "$replacefile") or die 'Unable to open replace file.';
	my @replace = <REPLACE>;
	close(REPLACE);

	open(TEMP, ">/tmp/temp") or die 'Unable to open temporary file.';
	flock TEMP, 2;

	my $found = 0;
	my $line;
	foreach $line (@target)
	{
		if ($found == 0)
		{
			if ($line eq "@search")
			{
				$found = 1;
				if ($linestodelete > 0)
				{
					$linestodelete--;
				}
				else {print TEMP "$line"; }
				my $repline;
				foreach $repline (@replace) {print TEMP $repline; }
			}
			else {print TEMP "$line"; }
		}
		else
		{
			if ($linestodelete > 0)
			{
				$linestodelete--;
			}
			else {print TEMP "$line"; }
		}
	}	
	close(TEMP);
	system "/bin/cp /tmp/temp $targetfile";
	system "/bin/rm -f /tmp/temp";
}


