#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal
#
###2006-0422 - install.pl from QoS v1.8 by NetWhiz modded by catastrophe for use with enhancedipblock v.0.2
###2006-0515 - modded by catastrophe for use with enhancedipblock v.0.3

require '/var/smoothwall/mods/enhancedipblock/modlib.pl';

# # # # # # # # # # # # # # # # # # #
# check for existing installations  #
# # # # # # # # # # # # # # # # # # #

print "\nInstalling Enhanced IP Block Page v.0.3, please wait...\n\n";

if (-e "/var/smoothwall/mods/enhancedipblock/installed") {
	if (&installed ("/var/smoothwall/mods/enhancedipblock/installed", "# enhancedipblock v.0.3")) {
		print "\nPlease remove Enhanced IP Block v.0.3\n";
		print "Note - Run uninstall.pl script.\n \n";
		exit;
	}
}

if (&installed ("/var/smoothwall/langs/base.pl", "# enhancedipblock v.0.3")) {
	print "\nPlease remove Enhanced IP Block v.0.3\n";
	print "Note - Run uninstall-020.pl script.\n \n";
	exit;
}

if (-e "/var/smoothwall/mods/enhancedipblock/installed") {
	if (&installed ("/var/smoothwall/mods/enhancedipblock/installed", "# enhancedipblock v.0.2")) {
		print "\nPlease remove Enhanced IP Block v.0.2\n";
		print "Note - Run uninstall-020.pl script.\n \n";
		exit;
	}
}

if (&installed ("/var/smoothwall/langs/base.pl", "# enhancedipblock v.0.2")) {
	print "\nPlease remove Enhanced IP Block v.0.2\n";
	print "Note - Run uninstall.pl script.\n \n";
	exit;
}

# # # # # # # # # # # #
# handle file copying #
# # # # # # # # # # # #

#	$storebkp =	where to store backup of the files that are changed by your mod
#	$moddir =	where your mod files are
#	$wkdir =	where you are changing files (backup from and copy to)
#
#	backupinstall ($file, $wkdir, $storebkp, $moddir);
#	backup ($file, $wkdir, $storebkp);
#	install ($file, $wkdir, $moddir);
#	uninstallrestore ($file, $wkdir, $storebkp);
#	uninstall ($file , $wkdir);
#
#	installed ($file, $string);
#
#	search for $string into $file => 1 found / 0 not found

my $bkp = '/var/smoothwall/mods/enhancedipblock/backup';

print "Creating backups ...\n";

$dir = '/home/httpd/cgi-bin';
&backup ('ipblock.cgi', $dir, $bkp);

$dir = '/home/httpd/html/help';
&backup ('ipblock.cgi.html.en', $dir, $bkp);

$dir = '/var/smoothwall/langs';
&backup ('base.pl', $dir, $bkp);

$dir = '/var/smoothwall/ipblock';
&backup ('config', $dir, $bkp);

my $mod = '/var/smoothwall/mods/enhancedipblock/modfiles';

print "Installing new files ...\n";

$dir = '/home/httpd/cgi-bin';
&install ('ipblock.cgi', $dir, $mod);

$dir = '/home/httpd/html/help';
&install ('ipblock.cgi.html.en', $dir, $mod);

print "Making any needed directories ...\n";

# # # # # # # # # # # #
# handle permissions  #
# # # # # # # # # # # #

# remove these lines when the web UI interface is ready
open (FILE, ">/var/smoothwall/preferences/dummy") or system ("/bin/su nobody -c '/bin/mkdir /var/smoothwall/preferences'");
close (FILE);
system ("/bin/rm -f /var/smoothwall/preferences/dummy");

# uncomment these lines when the web UI interface is ready
#open (FILE, ">/var/smoothwall/preferences/dummy") or system ("/bin/mkdir /var/smoothwall/preferences");
#close (FILE);
#system ("/bin/rm -f /var/smoothwall/preferences/dummy");

# # # # # # # # # # # #
# handle file editing #
# # # # # # # # # # # #

my $param = '/var/smoothwall/mods/enhancedipblock/params';

#&easymod ("/home/httpd/cgi-bin/.htaccess", "$param/htaccess.03.s", '0', "$param/htaccess.03.r");

&easymod ("/var/smoothwall/main/ui/alertboxes.en.pl", "$param/alertboxes.en.pl.03.s", '0', "$param/alertboxes.en.pl.03.r");

#&easymod ("/var/smoothwall/header.pl", "$param/header.pl.03.s", '0', "$param/header.pl.03.r");

&easymod ("/var/smoothwall/langs/base.pl", "$param/base.pl.03.s", '0', "$param/base.pl.03.r");

#&easymod ("/etc/crontab", "$param/crontab.03.s", '0', "$param/crontab.03.r");

# # # # # # # # # # # #
# handle file linking #
# # # # # # # # # # # #

#print "Creating GUI linked image ...\n";

#system ('/bin/ln -s /home/httpd/html/ui/assets/3.6/img/pagetitles/title-networking.png /home/httpd/html/ui/assets/3.6/img/pagetitles/page-enhancedipblock.png');

if (! -e "/var/smoothwall/ipblock/config2") { 	###use old blocklist if new blocklist does not exist
	system ('/bin/cp -p /var/smoothwall/ipblock/config /var/smoothwall/ipblock/config2');
}
$mod = '/var/smoothwall/mods/enhancedipblock/modfiles';
$dir = '/var/smoothwall/mods/enhancedipblock';
&install ('installed', $dir, $mod);

print "Done\n\n";

# # # #
# end #
# # # #
